## range-v3 0.10.0

=== CMakeLists.txt ===
# Copyright Eric Niebler 2014
# Copyright Gonzalo Brito Gadeschi 2014, 2017
# Copyright Louis Dionne 2015
# Copyright Casey Carter 2016
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE.md or copy at http://boost.org/LICENSE_1_0.txt)

cmake_minimum_required(VERSION 3.6)
get_directory_property(is_subproject PARENT_DIRECTORY)

if(NOT is_subproject)
    set(is_standalone YES)
else()
    set(is_standalone NO)
endif()

project(Range-v3 CXX)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON) # Export compilation data-base
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

add_library(range-v3-meta INTERFACE)
add_library(range-v3::meta ALIAS range-v3-meta)
target_include_directories(range-v3-meta INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>)
target_include_directories(range-v3-meta SYSTEM INTERFACE $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/include>)
target_compile_options(range-v3-meta INTERFACE $<$<CXX_COMPILER_ID:MSVC>:/permissive->)

add_library(range-v3-concepts INTERFACE)
add_library(range-v3::concepts ALIAS range-v3-concepts)
target_include_directories(range-v3-concepts INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>)
target_include_directories(range-v3-concepts SYSTEM INTERFACE $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/include>)
target_compile_options(range-v3-concepts INTERFACE $<$<CXX_COMPILER_ID:MSVC>:/permissive- /experimental:preprocessor /wd5105>)
target_link_libraries(range-v3-concepts INTERFACE range-v3::meta)

add_library(range-v3 INTERFACE)
add_library(range-v3::range-v3 ALIAS range-v3)
target_include_directories(range-v3 INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>)
target_include_directories(range-v3 SYSTEM INTERFACE $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/include>)
target_compile_options(range-v3 INTERFACE $<$<CXX_COMPILER_ID:MSVC>:/permissive->)
target_link_libraries(range-v3 INTERFACE range-v3::concepts range-v3::meta)

function(rv3_add_test TESTNAME EXENAME FIRSTSOURCE)
  add_executable(${EXENAME} ${FIRSTSOURCE} ${ARGN})
  target_link_libraries(${EXENAME} range-v3)
  add_test(${TESTNAME} ${EXENAME})
endfunction(rv3_add_test)

include(ranges_options)
include(ranges_env)
include(ranges_flags)

if(RANGE_V3_DOCS)
  add_subdirectory(doc)
endif()

if(RANGE_V3_TESTS)
  include(CTest)
  add_subdirectory(test)
endif()

if(RANGE_V3_EXAMPLES)
  add_subdirectory(example)
endif()

if(RANGE_V3_PERF)
  include(gtest)
  include(gbenchmark)
  add_subdirectory(perf)
endif()

# Add header files as sources to fix MSVS 2017 not finding source during debugging
file(GLOB_RECURSE RANGE_V3_PUBLIC_HEADERS_ABSOLUTE
                  "${CMAKE_CURRENT_SOURCE_DIR}/include/*.hpp")
add_custom_target(headers SOURCES ${RANGE_V3_PUBLIC_HEADERS_ABSOLUTE})
set_target_properties(headers PROPERTIES FOLDER "header")

# Test all headers
if(RANGE_V3_HEADER_CHECKS)
  include(TestHeaders)

  file(GLOB_RECURSE RANGE_V3_PUBLIC_HEADERS
                    RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}/include"
                    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.hpp")
  # These headers are not meant to be included directly:
  list(REMOVE_ITEM RANGE_V3_PUBLIC_HEADERS std/detail/associated_types.hpp)
  list(REMOVE_ITEM RANGE_V3_PUBLIC_HEADERS range/v3/detail/reenable_warnings.hpp)
  # Deprecated headers
  if(CMAKE_CXX_COMPILER_ID STREQUAL GNU)
    foreach(header ${RANGE_V3_PUBLIC_HEADERS})
      file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/include/${header}" is_deprecated
           LIMIT_COUNT 1
           REGEX ".*RANGES_DEPRECATED_HEADER.*")
      if(is_deprecated)
        list(APPEND RANGE_V3_DEPRECATED_PUBLIC_HEADERS "${header}")
      endif()
    endforeach()
  endif()

  add_header_test(test.range.v3.headers
    EXCLUDE ${RANGE_V3_DEPRECATED_PUBLIC_HEADERS}
    HEADERS ${RANGE_V3_PUBLIC_HEADERS})
  target_link_libraries(test.range.v3.headers PRIVATE range-v3)
endif()

# Grab the range-v3 version numbers:
include(${CMAKE_CURRENT_SOURCE_DIR}/Version.cmake)
set(RANGE_V3_VERSION ${RANGE_V3_MAJOR}.${RANGE_V3_MINOR}.${RANGE_V3_PATCHLEVEL})

# Try to build a new version.hpp
configure_file(version.hpp.in include/range/v3/version.hpp @ONLY)
file(STRINGS ${CMAKE_CURRENT_BINARY_DIR}/include/range/v3/version.hpp RANGE_V3_OLD_VERSION_HPP)
file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/include/range/v3/version.hpp RANGE_V3_NEW_VERSION_HPP)

# If the new version.hpp is materially different from the one in the source
# directory, update it, commit, and tag.
if(NOT RANGE_V3_NEW_VERSION_HPP STREQUAL RANGE_V3_OLD_VERSION_HPP)
  # Check that doc/release_notes.md and Version.cmake are the only changed file:
  execute_process(
    COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_CURRENT_SOURCE_DIR}" status --porcelain -uno
    OUTPUT_VARIABLE RANGE_V3_GIT_STATUS
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  string(REPLACE "\n" ";"  RANGE_V3_GIT_STATUS ${RANGE_V3_GIT_STATUS})
  if (NOT "x${RANGE_V3_GIT_STATUS}" STREQUAL "x M Version.cmake; M doc/release_notes.md")
    message(FATAL_ERROR "Cannot update version.hpp: range-v3 source directory has a dirty status")
  endif()
  file(
    COPY ${CMAKE_CURRENT_BINARY_DIR}/include/range/v3/version.hpp
    DESTINATION ${CMAKE_CURRENT_SOURCE_DIR}/include/range/v3
  )
  execute_process(
    COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_CURRENT_SOURCE_DIR}" add -u
  )
  execute_process(
    COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_CURRENT_SOURCE_DIR}" commit -m "${RANGE_V3_VERSION}"
  )
  execute_process(
    COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_CURRENT_SOURCE_DIR}" tag -f -a "${RANGE_V3_VERSION}" -m "${RANGE_V3_VERSION}"
  )
  find_program(CONAN_EXECUTABLE NAMES conan conan.exe)
  if (NOT "x${CONAN_EXECUTABLE}" STREQUAL "xCONAN_EXECUTABLE-NOTFOUND")
    message(STATUS "Exporting conanfile for new version")
    execute_process(
      COMMAND ${CONAN_EXECUTABLE} create . range-v3/${RANGE_V3_VERSION}@ericniebler/stable
      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    )
  endif()
  message(STATUS "Version updated to ${RANGE_V3_VERSION}. Don't forget to:")
  message(STATUS "  git push origin <feature-branch>")
  message(STATUS "and (after that is merged to master) then:")
  message(STATUS "  conan create ${CMAKE_CURRENT_SOURCE_DIR} range-v3/${RANGE_V3_VERSION}@ericniebler/stable")
  message(STATUS "  conan upload --all range-v3/${RANGE_V3_VERSION}@ericniebler/stable")
endif()

include(CMakePackageConfigHelpers)

# write_basic_package_version_file(...) gained ARCH_INDEPENDENT in CMake 3.14.
# For CMake 3.6, this workaround makes the version file ARCH_INDEPENDENT
# by making CMAKE_SIZEOF_VOID_P empty.
set(OLD_CMAKE_SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P})
set(CMAKE_SIZEOF_VOID_P "")
write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/range-v3-config-version.cmake
  VERSION ${RANGE_V3_VERSION}
  COMPATIBILITY ExactVersion
)
set(CMAKE_SIZEOF_VOID_P ${OLD_CMAKE_SIZEOF_VOID_P})

install(TARGETS range-v3-concepts range-v3-meta range-v3 EXPORT range-v3-targets DESTINATION lib)
install(EXPORT range-v3-targets FILE range-v3-targets.cmake DESTINATION lib/cmake/range-v3)
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/range-v3-config-version.cmake
  cmake/range-v3-config.cmake
  DESTINATION lib/cmake/range-v3)
install(DIRECTORY include/ DESTINATION include FILES_MATCHING PATTERN "*")

export(EXPORT range-v3-targets FILE range-v3-config.cmake)

=== test/CMakeLists.txt ===
include(../cmake/ranges_diagnostics.cmake)

set(CMAKE_FOLDER "test")

add_subdirectory(action)
add_subdirectory(algorithm)
add_subdirectory(iterator)
add_subdirectory(numeric)
add_subdirectory(range)
add_subdirectory(utility)
add_subdirectory(view)
add_subdirectory(experimental)

rv3_add_test(test.config config config.cpp)
rv3_add_test(test.constexpr_core constexpr_core constexpr_core.cpp)
rv3_add_test(test.multiple multiple multiple1.cpp multiple2.cpp)
rv3_add_test(test.bug474 bug474 bug474.cpp)
rv3_add_test(test.bug566 bug566 bug566.cpp)
rv3_add_test(test.bug1335 bug1335 bug1335.cpp)

=== test/iterator/CMakeLists.txt ===
set(CMAKE_FOLDER "${CMAKE_FOLDER}/iterator")

rv3_add_test(test.iter.basic_iterator iter.basic_iterator basic_iterator.cpp)
rv3_add_test(test.iter.diffmax_t iter.diffmax_t diffmax_t.cpp)
rv3_add_test(test.iter.iterator iter.iterator iterator.cpp)
rv3_add_test(test.iter.common_iterator iter.common_iterator common_iterator.cpp)
rv3_add_test(test.iter.reverse_iterator iter.reverse_iterator reverse_iterator.cpp)

=== test/utility/CMakeLists.txt ===
set(CMAKE_FOLDER "${CMAKE_FOLDER}/utility")

rv3_add_test(test.utility.box utility.box box.cpp)
rv3_add_test(test.utility.concepts utility.concepts concepts.cpp)
rv3_add_test(test.utility.common_type utility.common_type common_type.cpp)
rv3_add_test(test.utility.functional utility.functional functional.cpp)
rv3_add_test(test.utility.swap utility.swap swap.cpp)
rv3_add_test(test.utility.variant utility.variant variant.cpp)
rv3_add_test(test.utility.meta utility.meta meta.cpp)
rv3_add_test(test.utility.scope_exit utility.scope_exit scope_exit.cpp)

=== test/view/CMakeLists.txt ===
set(CMAKE_FOLDER "${CMAKE_FOLDER}/view")

rv3_add_test(test.view.adaptor view.adaptor adaptor.cpp)
rv3_add_test(test.view.addressof view.addressof addressof.cpp)
rv3_add_test(test.view.adjacent_remove_if view.adjacent_remove_if adjacent_remove_if.cpp)
rv3_add_test(test.view.all view.all all.cpp)
rv3_add_test(test.view.any_view view.any_view any_view.cpp)
rv3_add_test(test.view.common view.common common.cpp)
rv3_add_test(test.view.cache1 view.cache1 cache1.cpp)
rv3_add_test(test.view.cartesian_product view.cartesian_product cartesian_product.cpp)
rv3_add_test(test.view.chunk view.chunk chunk.cpp)
rv3_add_test(test.view.concat view.concat concat.cpp)
rv3_add_test(test.view.const view.const const.cpp)
rv3_add_test(test.view.conversion view.conversion conversion.cpp)
rv3_add_test(test.view.counted view.counted counted.cpp)
rv3_add_test(test.view.cycle view.cycle cycle.cpp)
rv3_add_test(test.view.delimit view.delimit delimit.cpp)
rv3_add_test(test.view.drop view.drop drop.cpp)
rv3_add_test(test.view.drop_exactly view.drop_exactly drop_exactly.cpp)
rv3_add_test(test.view.drop_while view.drop_while drop_while.cpp)
rv3_add_test(test.view.drop_last view.drop_last drop_last.cpp)
rv3_add_test(test.view.enumerate view.enumerate enumerate.cpp)
rv3_add_test(test.view.exclusive_scan view.exclusive_scan exclusive_scan.cpp)
rv3_add_test(test.view.facade view.facade facade.cpp)
rv3_add_test(test.view.generate view.generate generate.cpp)
rv3_add_test(test.view.generate_n view.generate_n generate_n.cpp)
rv3_add_test(test.view.getlines view.getlines getlines.cpp)
rv3_add_test(test.view.group_by view.group_by group_by.cpp)
rv3_add_test(test.view.indirect view.indirect indirect.cpp)
rv3_add_test(test.view.intersperse view.intersperse intersperse.cpp)
rv3_add_test(test.view.iota view.iota iota.cpp)
rv3_add_test(test.view.istream view.istream istream.cpp)
rv3_add_test(test.view.iterator_range view.iterator_range iterator_range.cpp)
rv3_add_test(test.view.join view.join join.cpp)
rv3_add_test(test.view.linear_distribute view.linear_distribute linear_distribute.cpp)
rv3_add_test(test.view.map view.map keys_value.cpp)
rv3_add_test(test.view.move view.move move.cpp)
rv3_add_test(test.view.partial_sum view.partial_sum partial_sum.cpp)
# rv3_add_test(test.view.partial_sum_depr view.partial_sum_depr partial_sum_depr.cpp)
rv3_add_test(test.view.repeat view.repeat repeat.cpp)
rv3_add_test(test.view.remove view.remove remove.cpp)
rv3_add_test(test.view.remove_if view.remove_if remove_if.cpp)
rv3_add_test(test.view.replace view.replace replace.cpp)
rv3_add_test(test.view.replace_if view.replace_if replace_if.cpp)
rv3_add_test(test.view.reverse view.reverse reverse.cpp)
rv3_add_test(test.view.sample view.sample sample.cpp)
rv3_add_test(test.view.set_difference view.set_difference set_difference.cpp)
rv3_add_test(test.view.set_intersection view.set_intersection set_intersection.cpp)
rv3_add_test(test.view.set_symmetric_difference view.set_symmetric_difference set_symmetric_difference.cpp)
rv3_add_test(test.view.set_union view.set_union set_union.cpp)
rv3_add_test(test.view.slice view.slice slice.cpp)
rv3_add_test(test.view.sliding view.sliding sliding.cpp)
rv3_add_test(test.view.span view.span span.cpp)
rv3_add_test(test.view.split view.split split.cpp)
rv3_add_test(test.view.stride view.stride stride.cpp)
rv3_add_test(test.view.subrange view.subrange subrange.cpp)
rv3_add_test(test.view.tail view.tail tail.cpp)
rv3_add_test(test.view.take view.take take.cpp)
rv3_add_test(test.view.take_exactly view.take_exactly take_exactly.cpp)
rv3_add_test(test.view.take_last view.take_last take_last.cpp)
rv3_add_test(test.view.take_while view.take_while take_while.cpp)
rv3_add_test(test.view.tokenize view.tokenize tokenize.cpp)
rv3_add_test(test.view.transform view.transform transform.cpp)
rv3_add_test(test.view.trim view.trim trim.cpp)
rv3_add_test(test.view.unique view.unique unique.cpp)
rv3_add_test(test.view.view view.view view.cpp)
rv3_add_test(test.view.zip view.zip zip.cpp)

target_compile_definitions(view.iterator_range PRIVATE RANGES_DISABLE_DEPRECATED_WARNINGS)

=== debian/changelog ===
range-v3 (0.10.0-1) unstable; urgency=medium

  * New upstream release.
  * Add Strip-doc-from-path.patch to avoid dependency on build directory.
  * Bump Standards-Version to 4.4.1, no changes related to this.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Fri, 20 Dec 2019 14:54:44 +0300

=== debian/control ===
Source: range-v3
Section: libdevel
Priority: optional
Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
Build-Depends: debhelper-compat (= 12)
Build-Depends-Indep:
 cmake (>= 3.6.0),
 doxygen (>= 1.8.13) <!nodoc>,
 doxygen-latex (>= 1.8.13) <!nodoc>,
 libboost-date-time-dev (>= 1.59.0) <!nocheck>,
 libboost-program-options-dev (>= 1.59.0) <!nocheck>,
Standards-Version: 4.4.1
Rules-Requires-Root: no
Homepage: https://github.com/ericniebler/range-v3
Vcs-Git: https://salsa.debian.org/debian/range-v3.git
Vcs-Browser: https://salsa.debian.org/debian/range-v3

Package: librange-v3-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: librange-v3-doc
Description: range algorithms, views, and actions for C++14/17/20 - headers
 Range-v3 is a generic library that augments the existing standard library with
 facilities for working with ranges. A range can be loosely thought of a pair
 of iterators. This library provides a full implementation of all the standard
 algorithms with range-based overloads for convenience.
 .
 This package contains headers of the library.

Package: librange-v3-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: range algorithms, views, and actions for C++14/17/20 - documentation
 Range-v3 is a generic library that augments the existing standard library with
 facilities for working with ranges. A range can be loosely thought of a pair
 of iterators. This library provides a full implementation of all the standard
 algorithms with range-based overloads for convenience.
 .
 This package ships HTML documentation of the library.

=== debian/rules ===
#!/usr/bin/make -f

EXTRA_CMAKE_VARIABLES = \
	CMAKE_SKIP_INSTALL_ALL_DEPENDENCY=ON \
	RANGE_V3_HEADER_CHECKS=ON \
	RANGES_NATIVE=OFF \
	RANGES_VERBOSE_BUILD=ON

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CMAKE_VARIABLES:%=-D%)

# Range-v3 is header library so we should make only online documentation unless
# the `nodoc` flag is specified.
override_dh_auto_build:
ifeq (,$(filter nodoc, $(DEB_BUILD_OPTIONS)))
	dh_auto_build -- doc
endif

# The `test` target doesn't compile tests by itself and fails if they aren't
# built before.
override_dh_auto_test:
ifeq (,$(filter nocheck, $(DEB_BUILD_OPTIONS)))
	dh_auto_build
	dh_auto_test
endif

override_dh_installchangelogs:
	dh_installchangelogs doc/release_notes.md

## range-v3 0.11.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,7 +30,7 @@
 add_library(range-v3::concepts ALIAS range-v3-concepts)
 target_include_directories(range-v3-concepts INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>)
 target_include_directories(range-v3-concepts SYSTEM INTERFACE $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/include>)
-target_compile_options(range-v3-concepts INTERFACE $<$<CXX_COMPILER_ID:MSVC>:/permissive- /experimental:preprocessor /wd5105>)
+target_compile_options(range-v3-concepts INTERFACE $<$<CXX_COMPILER_ID:MSVC>:/permissive->)
 target_link_libraries(range-v3-concepts INTERFACE range-v3::meta)
 
 add_library(range-v3 INTERFACE)
@@ -84,7 +84,7 @@
                     "${CMAKE_CURRENT_SOURCE_DIR}/include/*.hpp")
   # These headers are not meant to be included directly:
   list(REMOVE_ITEM RANGE_V3_PUBLIC_HEADERS std/detail/associated_types.hpp)
-  list(REMOVE_ITEM RANGE_V3_PUBLIC_HEADERS range/v3/detail/reenable_warnings.hpp)
+  list(REMOVE_ITEM RANGE_V3_PUBLIC_HEADERS range/v3/detail/epilogue.hpp)
   # Deprecated headers
   if(CMAKE_CXX_COMPILER_ID STREQUAL GNU)
     foreach(header ${RANGE_V3_PUBLIC_HEADERS})

=== doc/CMakeLists.txt ===
#=============================================================================
# Setup the documentation
#=============================================================================
if (NOT DOXYGEN_FOUND)
    message(STATUS
    "Doxygen not found; the 'doc' and 'gh-pages.{clean,copy,update}' targets "
    "will be unavailable.")
    return()
endif()

set(CMAKE_FOLDER "doc")

configure_file(Doxyfile.in Doxyfile @ONLY)
configure_file(preprocess.sh.in preprocess.sh @ONLY)
add_custom_target(doc.check
    COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile
    COMMENT "Running Doxygen to validate the documentation"
    VERBATIM
)
set_target_properties(doc.check
    PROPERTIES FOLDER ${CMAKE_FOLDER}
)

# if (NOT TARGET benchmarks)
#     message(STATUS
#         "The 'benchmarks' target is not available; the 'doc' and "
#         "'gh-pages.{clean,copy,update}' targets will be unavailable. "
#         "The 'doc.check' target can still be used to generate the "
#         "documentation to check for errors/warnings.")
#     return()
# endif()

add_custom_target(doc
    COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile
    COMMENT "Generating API documentation with Doxygen"
#     DEPENDS benchmarks
    VERBATIM
)
set_target_properties(doc
    PROPERTIES FOLDER ${CMAKE_FOLDER}
)

if (NOT GIT_FOUND)
    message(STATUS
    "Git was not found; the 'gh-pages.{clean,copy,update}' targets "
    "will be unavailable.")
    return()
endif()

add_custom_target(gh-pages.clean
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_LIST_DIR}/clean-gh-pages.cmake
    COMMAND ${CMAKE_COMMAND} -E remove_directory search
    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/gh-pages
    COMMENT "Cleaning up doc/gh-pages"
    VERBATIM
)
set_target_properties(gh-pages.clean
    PROPERTIES FOLDER ${CMAKE_FOLDER}
)

add_custom_target(gh-pages.copy
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_BINARY_DIR}/html ${CMAKE_CURRENT_LIST_DIR}/gh-pages
    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/gh-pages
    COMMENT "Copying the documentation from ${CMAKE_CURRENT_BINARY_DIR}/html to doc/gh-pages"
    DEPENDS doc gh-pages.clean
    VERBATIM
)
set_target_properties(gh-pages.copy
    PROPERTIES FOLDER ${CMAKE_FOLDER}
)

execute_process(
    COMMAND ${GIT_EXECUTABLE} -C ${CMAKE_SOURCE_DIR} rev-parse --short HEAD
    OUTPUT_VARIABLE RANGE_V3_GIT_SHORT_SHA
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

add_custom_target(gh-pages.update
    COMMAND ${GIT_EXECUTABLE} add --all .
    COMMAND ${GIT_EXECUTABLE} commit -m "Update to ${RANGE_V3_GIT_SHORT_SHA}"
    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/gh-pages
    COMMENT "Updating the gh-pages branch with freshly built documentation"
    DEPENDS gh-pages.copy
    VERBATIM
)
set_target_properties(gh-pages.update
    PROPERTIES FOLDER ${CMAKE_FOLDER}
)

=== example/CMakeLists.txt ===
set(CMAKE_FOLDER "example")

# examples use a less draconian set of compiler warnings
ranges_append_flag(RANGES_HAS_WNO_MISSING_BRACES -Wno-missing-braces)
ranges_append_flag(RANGES_HAS_WNO_SHORTEN_64_TO_32 -Wno-shorten-64-to-32)
ranges_append_flag(RANGES_HAS_WNO_GLOBAL_CONSTRUCTORS -Wno-global-constructors)

rv3_add_test(example.comprehensions comprehensions comprehensions.cpp)
rv3_add_test(example.hello hello hello.cpp)
rv3_add_test(example.count count count.cpp)
rv3_add_test(example.count_if count_if count_if.cpp)
rv3_add_test(example.any_all_none_of any_all_none_of any_all_none_of.cpp)
rv3_add_test(example.for_each_sequence for_each_sequence for_each_sequence.cpp)
rv3_add_test(example.for_each_assoc for_each_assoc for_each_assoc.cpp)
rv3_add_test(example.is_sorted is_sorted is_sorted.cpp)
rv3_add_test(example.find find find.cpp)
rv3_add_test(example.filter_transform filter_transform filter_transform.cpp)
rv3_add_test(example.accumulate_ints accumulate_ints accumulate_ints.cpp)
rv3_add_test(example.comprehension_conversion comprehension_conversion comprehension_conversion.cpp)
rv3_add_test(example.sort_unique sort_unique sort_unique.cpp)

# Guarded with a variable because the calendar example causes gcc to puke.
if(RANGES_BUILD_CALENDAR_EXAMPLE)
    set(Boost_USE_STATIC_LIBS        ON)
    set(Boost_USE_MULTITHREADED     OFF)
    set(Boost_USE_STATIC_RUNTIME    OFF)
    find_package(Boost 1.59.0 COMPONENTS date_time program_options)

    if (Boost_FOUND)
        add_executable(calendar calendar.cpp)
        target_include_directories(calendar SYSTEM PRIVATE ${Boost_INCLUDE_DIRS})
        target_link_libraries(calendar PRIVATE range-v3 Boost::date_time Boost::program_options)
        message(STATUS "boost: ${Boost_LIBRARY_DIRS}")
        target_compile_definitions(calendar PRIVATE BOOST_NO_AUTO_PTR)
        target_compile_options(calendar PRIVATE -std=gnu++14)
    endif()
endif()

=== perf/CMakeLists.txt ===
set(CMAKE_FOLDER "perf")

add_executable(counted_insertion_sort counted_insertion_sort.cpp)
target_link_libraries(counted_insertion_sort range-v3)

add_executable(range_conversion range_conversion.cpp)
target_link_libraries(range_conversion range-v3 benchmark_main)

add_executable(sort_patterns sort_patterns.cpp)
target_link_libraries(sort_patterns range-v3)

=== test_package/CMakeLists.txt ===
# Range v3 library
#
#  Copyright Luis Martinez de Bartolome Izquierdo 2016
#
#  Use, modification and distribution is subject to the
#  Boost Software License, Version 1.0. (See accompanying
#  file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
#
# Project home: https://github.com/ericniebler/range-v3
#

PROJECT(PackageTest)
cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR)

include(${CMAKE_BINARY_DIR}/conanbuildinfo.cmake)
conan_basic_setup()

add_executable(example example.cpp)

target_link_libraries(example ${CONAN_LIBS})

set_property(TARGET example PROPERTY CXX_STANDARD 17)

=== test/algorithm/CMakeLists.txt ===
set(CMAKE_FOLDER "${CMAKE_FOLDER}/algorithm")

rv3_add_test(test.alg.adjacent_find alg.adjacent_find adjacent_find.cpp)
rv3_add_test(test.alg.adjacent_remove_if alg.adjacent_remove_if adjacent_remove_if.cpp)
rv3_add_test(test.alg.all_of alg.all_of all_of.cpp)
rv3_add_test(test.alg.any_of alg.any_of any_of.cpp)
rv3_add_test(test.alg.none_of alg.none_of none_of.cpp)
rv3_add_test(test.alg.binary_search alg.binary_search binary_search.cpp)
rv3_add_test(test.alg.contains alg.contains contains.cpp)
rv3_add_test(test.alg.copy alg.copy copy.cpp)
rv3_add_test(test.alg.copy_backward alg.copy_backward copy_backward.cpp)
rv3_add_test(test.alg.count alg.count count.cpp)
rv3_add_test(test.alg.count_if alg.count_if count_if.cpp)
rv3_add_test(test.alg.ends_with alg.ends_with ends_with.cpp)
rv3_add_test(test.alg.equal alg.equal equal.cpp)
rv3_add_test(test.alg.equal_range alg.equal_range equal_range.cpp)
rv3_add_test(test.alg.fill alg.fill fill.cpp)
rv3_add_test(test.alg.find alg.find find.cpp)
rv3_add_test(test.alg.find_end alg.find_end find_end.cpp)
rv3_add_test(test.alg.find_if alg.find_if find_if.cpp)
rv3_add_test(test.alg.find_first_of alg.find_first_of find_first_of.cpp)
rv3_add_test(test.alg.for_each alg.for_each for_each.cpp)
rv3_add_test(test.alg.for_each_n alg.for_each_n for_each_n.cpp)
rv3_add_test(test.alg.generate alg.generate generate.cpp)
rv3_add_test(test.alg.generate_n alg.generate_n generate_n.cpp)
rv3_add_test(test.alg.includes alg.includes includes.cpp)
rv3_add_test(test.alg.inplace_merge alg.inplace_merge inplace_merge.cpp)
rv3_add_test(test.alg.is_heap1 alg.is_heap1 is_heap1.cpp)
rv3_add_test(test.alg.is_heap2 alg.is_heap2 is_heap2.cpp)
rv3_add_test(test.alg.is_heap3 alg.is_heap3 is_heap3.cpp)
rv3_add_test(test.alg.is_heap4 alg.is_heap4 is_heap4.cpp)
rv3_add_test(test.alg.is_heap_until1 alg.is_heap_until1 is_heap_until1.cpp)
rv3_add_test(test.alg.is_heap_until2 alg.is_heap_until2 is_heap_until2.cpp)
rv3_add_test(test.alg.is_heap_until3 alg.is_heap_until3 is_heap_until3.cpp)
rv3_add_test(test.alg.is_heap_until4 alg.is_heap_until4 is_heap_until4.cpp)
rv3_add_test(test.alg.is_partitioned alg.is_partitioned is_partitioned.cpp)
rv3_add_test(test.alg.is_permutation alg.is_permutation is_permutation.cpp)
rv3_add_test(test.alg.is_sorted_until alg.is_sorted_until is_sorted_until.cpp)
rv3_add_test(test.alg.is_sorted alg.is_sorted is_sorted.cpp)
rv3_add_test(test.alg.lexicographical_compare alg.lexicographical_compare lexicographical_compare.cpp)
rv3_add_test(test.alg.lower_bound alg.lower_bound lower_bound.cpp)
rv3_add_test(test.alg.make_heap alg.make_heap make_heap.cpp)
rv3_add_test(test.alg.max alg.max max.cpp)
rv3_add_test(test.alg.max_element alg.max_element max_element.cpp)
rv3_add_test(test.alg.merge alg.merge merge.cpp)
rv3_add_test(test.alg.min alg.min min.cpp)
rv3_add_test(test.alg.min_element alg.min_element min_element.cpp)
rv3_add_test(test.alg.minmax alg.minmax minmax.cpp)
rv3_add_test(test.alg.minmax_element alg.minmax_element minmax_element.cpp)
rv3_add_test(test.alg.mismatch alg.mismatch mismatch.cpp)
rv3_add_test(test.alg.move alg.move move.cpp)
rv3_add_test(test.alg.move_backward alg.move_backward move_backward.cpp)
rv3_add_test(test.alg.next_permutation alg.next_permutation next_permutation.cpp)
rv3_add_test(test.alg.nth_element alg.nth_element nth_element.cpp)
rv3_add_test(test.alg.partial_sort alg.partial_sort partial_sort.cpp)
rv3_add_test(test.alg.partial_sort_copy alg.partial_sort_copy partial_sort_copy.cpp)
rv3_add_test(test.alg.partition alg.partition partition.cpp)
rv3_add_test(test.alg.partition_copy alg.partition_copy partition_copy.cpp)
rv3_add_test(test.alg.partition_point alg.partition_point partition_point.cpp)
rv3_add_test(test.alg.pop_heap alg.pop_heap pop_heap.cpp)
rv3_add_test(test.alg.prev_permutation alg.prev_permutation prev_permutation.cpp)
rv3_add_test(test.alg.push_heap alg.push_heap push_heap.cpp)
rv3_add_test(test.alg.remove alg.remove remove.cpp)
rv3_add_test(test.alg.remove_copy alg.remove_copy remove_copy.cpp)
rv3_add_test(test.alg.remove_copy_if alg.remove_copy_if remove_copy_if.cpp)
rv3_add_test(test.alg.remove_if alg.remove_if remove_if.cpp)
rv3_add_test(test.alg.replace alg.replace replace.cpp)
rv3_add_test(test.alg.replace_copy alg.replace_copy replace_copy.cpp)
rv3_add_test(test.alg.replace_copy_if alg.replace_copy_if replace_copy_if.cpp)
rv3_add_test(test.alg.replace_if alg.replace_if replace_if.cpp)
rv3_add_test(test.alg.reverse alg.reverse reverse.cpp)
rv3_add_test(test.alg.reverse_copy alg.reverse_copy reverse_copy.cpp)
rv3_add_test(test.alg.rotate alg.rotate rotate.cpp)
rv3_add_test(test.alg.rotate_copy alg.rotate_copy rotate_copy.cpp)
rv3_add_test(test.alg.sample alg.sample sample.cpp)
rv3_add_test(test.alg.search alg.search search.cpp)
rv3_add_test(test.alg.search_n alg.search_n search_n.cpp)
rv3_add_test(test.alg.set_difference1 alg.set_difference1 set_difference1.cpp)
rv3_add_test(test.alg.set_difference2 alg.set_difference2 set_difference2.cpp)
rv3_add_test(test.alg.set_difference3 alg.set_difference3 set_difference3.cpp)
rv3_add_test(test.alg.set_difference4 alg.set_difference4 set_difference4.cpp)
rv3_add_test(test.alg.set_difference5 alg.set_difference5 set_difference5.cpp)
rv3_add_test(test.alg.set_difference6 alg.set_difference6 set_difference6.cpp)
rv3_add_test(test.alg.set_intersection1 alg.set_intersection1 set_intersection1.cpp)
rv3_add_test(test.alg.set_intersection2 alg.set_intersection2 set_intersection2.cpp)
rv3_add_test(test.alg.set_intersection3 alg.set_intersection3 set_intersection3.cpp)
rv3_add_test(test.alg.set_intersection4 alg.set_intersection4 set_intersection4.cpp)
rv3_add_test(test.alg.set_intersection5 alg.set_intersection5 set_intersection5.cpp)
rv3_add_test(test.alg.set_intersection6 alg.set_intersection6 set_intersection6.cpp)
rv3_add_test(test.alg.set_symmetric_difference1 alg.set_symmetric_difference1 set_symmetric_difference1.cpp)
rv3_add_test(test.alg.set_symmetric_difference2 alg.set_symmetric_difference2 set_symmetric_difference2.cpp)
rv3_add_test(test.alg.set_symmetric_difference3 alg.set_symmetric_difference3 set_symmetric_difference3.cpp)
rv3_add_test(test.alg.set_symmetric_difference4 alg.set_symmetric_difference4 set_symmetric_difference4.cpp)
rv3_add_test(test.alg.set_symmetric_difference5 alg.set_symmetric_difference5 set_symmetric_difference5.cpp)
rv3_add_test(test.alg.set_symmetric_difference6 alg.set_symmetric_difference6 set_symmetric_difference6.cpp)
rv3_add_test(test.alg.set_union1 alg.set_union1 set_union1.cpp)
rv3_add_test(test.alg.set_union2 alg.set_union2 set_union2.cpp)
rv3_add_test(test.alg.set_union3 alg.set_union3 set_union3.cpp)
rv3_add_test(test.alg.set_union4 alg.set_union4 set_union4.cpp)
rv3_add_test(test.alg.set_union5 alg.set_union5 set_union5.cpp)
rv3_add_test(test.alg.set_union6 alg.set_union6 set_union6.cpp)
rv3_add_test(test.alg.shuffle alg.shuffle shuffle.cpp)
rv3_add_test(test.alg.sort alg.sort sort.cpp)
rv3_add_test(test.alg.sort_heap alg.sort_heap sort_heap.cpp)
rv3_add_test(test.alg.stable_partition alg.stable_partition stable_partition.cpp)
rv3_add_test(test.alg.stable_sort alg.stable_sort stable_sort.cpp)
rv3_add_test(test.alg.starts_with alg.starts_with starts_with.cpp)
rv3_add_test(test.alg.swap_ranges alg.swap_ranges swap_ranges.cpp)
rv3_add_test(test.alg.transform alg.transform transform.cpp)
rv3_add_test(test.alg.unique alg.unique unique.cpp)
rv3_add_test(test.alg.unique_copy alg.unique_copy unique_copy.cpp)
rv3_add_test(test.alg.upper_bound alg.upper_bound upper_bound.cpp)
rv3_add_test(test.alg.sort_n_with_buffer alg.sort_n_with_buffer sort_n_with_buffer.cpp)

=== test/functional/CMakeLists.txt ===
set(CMAKE_FOLDER "${CMAKE_FOLDER}/algorithm")

rv3_add_test(test.fun.bind_back fun.bind_back bind_back.cpp)

=== debian/changelog ===
range-v3 (0.11.0-2) unstable; urgency=medium

  * Reupload the fix to unstable.
  * Bump Standards-Version to 4.6.0, no required changes.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Wed, 01 Dec 2021 00:06:04 +0300

range-v3 (0.11.0-1.1) unstable; urgency=high

  * Non-maintainer upload.
  * Apply suggested fix for gcc 11.2. Closes: #997289.

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 13 Nov 2021 11:26:59 +0100

range-v3 (0.11.0-1) unstable; urgency=medium

  [ Nicholas Guriev ]
  * New upstream release (closes: #968053).
    - Adjust build scripts for GCC 10 (closes: #966900).
  * Patches:
    - Remove no longer needed Strip-doc-from-path.patch.
    - Import Detection-of-concepts.patch from upstream Git.
    - Add Workaround-premature-instantiation.patch based on upstream commit.
  * Update DebHelper compatibility level to 13.
  * Bump standards version to 4.5.0, no required changes.

  [ Michael R. Crusoe ]
  * Add upstream metadata.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Tue, 18 Aug 2020 09:46:44 +0300

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,14 @@
 Section: libdevel
 Priority: optional
 Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
-Build-Depends: debhelper-compat (= 12)
+Build-Depends: debhelper-compat (= 13)
 Build-Depends-Indep:
  cmake (>= 3.6.0),
  doxygen (>= 1.8.13) <!nodoc>,
  doxygen-latex (>= 1.8.13) <!nodoc>,
  libboost-date-time-dev (>= 1.59.0) <!nocheck>,
  libboost-program-options-dev (>= 1.59.0) <!nocheck>,
-Standards-Version: 4.4.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://github.com/ericniebler/range-v3
 Vcs-Git: https://salsa.debian.org/debian/range-v3.git

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,6 @@
 #!/usr/bin/make -f
 
 EXTRA_CMAKE_VARIABLES = \
-	CMAKE_SKIP_INSTALL_ALL_DEPENDENCY=ON \
 	RANGE_V3_HEADER_CHECKS=ON \
 	RANGES_NATIVE=OFF \
 	RANGES_VERBOSE_BUILD=ON
@@ -20,12 +19,10 @@
 endif
 
 # The `test` target doesn't compile tests by itself and fails if they aren't
-# built before.
+# built before. Build the tests if only the `nocheck` flag is absent.
 override_dh_auto_test:
-ifeq (,$(filter nocheck, $(DEB_BUILD_OPTIONS)))
 	dh_auto_build
 	dh_auto_test
-endif
 
 override_dh_installchangelogs:
 	dh_installchangelogs doc/release_notes.md

## range-v3 0.12.0

=== doc/CMakeLists.txt ===
#=============================================================================
# Setup the documentation
#=============================================================================
if (NOT DOXYGEN_FOUND)
    message(STATUS
    "Doxygen not found; the 'range-v3-doc' and 'range-v3-gh-pages.{clean,copy,update}' targets "
    "will be unavailable.")
    return()
endif()

set(CMAKE_FOLDER "doc")

configure_file(Doxyfile.in Doxyfile @ONLY)
configure_file(preprocess.sh.in preprocess.sh @ONLY)
add_custom_target(range.v3.doc.check
    COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile
    COMMENT "Running Doxygen to validate the documentation"
    VERBATIM
)
set_target_properties(range.v3.doc.check
    PROPERTIES FOLDER ${CMAKE_FOLDER}
)

# if (NOT TARGET benchmarks)
#     message(STATUS
#         "The 'benchmarks' target is not available; the 'doc' and "
#         "'gh-pages.{clean,copy,update}' targets will be unavailable. "
#         "The 'doc.check' target can still be used to generate the "
#         "documentation to check for errors/warnings.")
#     return()
# endif()

add_custom_target(range-v3-doc
    COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile
    COMMENT "Generating API documentation with Doxygen"
#     DEPENDS range-v3-benchmarks
    VERBATIM
)
set_target_properties(range-v3-doc
    PROPERTIES FOLDER ${CMAKE_FOLDER}
)

if (NOT GIT_FOUND)
    message(STATUS
    "Git was not found; the 'range-v3-gh-pages.{clean,copy,update}' targets "
    "will be unavailable.")
    return()
endif()

add_custom_target(range-v3-gh-pages.clean
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_LIST_DIR}/clean-gh-pages.cmake
    COMMAND ${CMAKE_COMMAND} -E remove_directory search
    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/gh-pages
    COMMENT "Cleaning up doc/gh-pages"
    VERBATIM
)
set_target_properties(range-v3-gh-pages.clean
    PROPERTIES FOLDER ${CMAKE_FOLDER}
)

add_custom_target(range-v3-gh-pages.copy
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_BINARY_DIR}/html ${CMAKE_CURRENT_LIST_DIR}/gh-pages
    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/gh-pages
    COMMENT "Copying the documentation from ${CMAKE_CURRENT_BINARY_DIR}/html to doc/gh-pages"
    DEPENDS range-v3-doc range-v3-gh-pages.clean
    VERBATIM
)
set_target_properties(range-v3-gh-pages.copy
    PROPERTIES FOLDER ${CMAKE_FOLDER}
)

execute_process(
    COMMAND ${GIT_EXECUTABLE} -C ${CMAKE_SOURCE_DIR} rev-parse --short HEAD
    OUTPUT_VARIABLE RANGE_V3_GIT_SHORT_SHA
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

add_custom_target(range-v3-gh-pages.update
    COMMAND ${GIT_EXECUTABLE} add --all .
    COMMAND ${GIT_EXECUTABLE} commit -m "Update to ${RANGE_V3_GIT_SHORT_SHA}"
    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/gh-pages
    COMMENT "Updating the gh-pages branch with freshly built documentation"
    DEPENDS range-v3-gh-pages.copy
    VERBATIM
)
set_target_properties(range-v3-gh-pages.update
    PROPERTIES FOLDER ${CMAKE_FOLDER}
)

=== test/experimental/CMakeLists.txt ===
set(CMAKE_FOLDER "${CMAKE_FOLDER}/experimental")

add_subdirectory(utility)
add_subdirectory(view)

=== debian/changelog ===
range-v3 (0.12.0-2) unstable; urgency=medium

  * Enable building tests again but do not fail on false positive
    -Wmaybe-uninitialized warnings.
  * Add Show-topics.patch to fix navigation in the documentation.
  * Remove unused doxygen-latex build dependency.
  * Update Standards-Version to 4.7.2.
    - Migrate to dpkg-build-api v1.
    - Remove the Rules-Requires-Root field.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 29 Nov 2025 12:55:53 +0300

range-v3 (0.12.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Disable building tests (Closes: #1077433).

 -- Andrey Rakhmatullin <wrar@debian.org>  Wed, 11 Sep 2024 14:01:33 +0500

range-v3 (0.12.0-1) unstable; urgency=medium

  * New upstream release.
  * Remove accepted patches,
    - Detection-of-concepts.patch
    - Workaround-premature-instantiation.patch
  * Replace gcc-11.2.patch with rewritten Fix-circular-swap.patch.
  * Bump Standards-Version to 4.6.1, no required changes.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Fri, 24 Jun 2022 18:52:54 +0300

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,13 @@
 Section: libdevel
 Priority: optional
 Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
-Build-Depends: debhelper-compat (= 13)
+Build-Depends: debhelper-compat (= 13), dpkg-build-api (= 1)
 Build-Depends-Indep:
  cmake (>= 3.6.0),
  doxygen (>= 1.8.13) <!nodoc>,
- doxygen-latex (>= 1.8.13) <!nodoc>,
  libboost-date-time-dev (>= 1.59.0) <!nocheck>,
  libboost-program-options-dev (>= 1.59.0) <!nocheck>,
-Standards-Version: 4.6.0
-Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Homepage: https://github.com/ericniebler/range-v3
 Vcs-Git: https://salsa.debian.org/debian/range-v3.git
 Vcs-Browser: https://salsa.debian.org/debian/range-v3

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,10 @@
 #!/usr/bin/make -f
 
+# A lot of mysterious false positives. Do not fail tests.
+export DEB_CXXFLAGS_MAINT_APPEND = -Wno-error=maybe-uninitialized
+
 EXTRA_CMAKE_VARIABLES = \
+	CMAKE_INSTALL_LIBDIR=lib \
 	RANGE_V3_HEADER_CHECKS=ON \
 	RANGES_NATIVE=OFF \
 	RANGES_VERBOSE_BUILD=ON
@@ -15,7 +19,7 @@
 # the `nodoc` flag is specified.
 override_dh_auto_build:
 ifeq (,$(filter nodoc, $(DEB_BUILD_OPTIONS)))
-	dh_auto_build -- doc
+	dh_auto_build -- range-v3-doc
 endif
 
 # The `test` target doesn't compile tests by itself and fails if they aren't

=== debian/watch ===
version=4
opts=" \
  downloadurlmangle=s%releases/tag/(v?@ANY_VERSION@)$%archive/refs/tags/$1.tar.gz% ,\
  filenamemangle=s%(?:.*?/)?v?@ANY_VERSION@$%@PACKAGE@-$1.tar.gz% ,\
" https://github.com/ericniebler/range-v3/releases/latest tag/v?@ANY_VERSION@$
